using System;
using System.Security.Cryptography;
using System.Text;
using System.IO;

class AESBeispiel
{
    static void Main()
    {
        try
        {
            // Erzeugen einer neuen RijndaelManaged-Instanz samt Schlssel und IV
            RijndaelManaged aesAlg = new RijndaelManaged();

            // Schlssel und IV in eigenen Variablen speichern 
            // (dient nur der bersichtlichkeit)
            byte[] AESkey = aesAlg.Key;
            byte[] AESiv  = aesAlg.IV;

            // Der zu verschlsselnde Klartext
            string klartext = "Dieser Text ist streng geheim!";

            // Der Name der Zieldatei
            string zieldatei = "schluesseltext.txt";

            // Verschlsseln des Klartextes mit dem erzeugten Schlssel und IV
            AESVerschluessele(klartext, zieldatei, AESkey, AESiv);

            // Entschlsseln der Daten aus der Datei mit dem verwendeten Schlssel
            // und IV
            string entschluesselt = AESEntschluessele(zieldatei, AESkey, AESiv);

            // Ausgabe des Klartextes und des entschlsselten Textes
            Console.WriteLine("Klartext:      {0}", klartext);
            Console.WriteLine("Entschlsselt: {0}", entschluesselt);

            // Vertrauliche Daten lschen
            aesAlg.Clear();
        }
        catch (Exception e)
        {
             Console.WriteLine("Fehler: {0}", e.Message);
        }
    }


    public static void AESVerschluessele(String klartext, String dateiname, byte[] schluessel, byte[] iv)
    {
        try
        {
            // ffnen oder Anlegen der Datei
            FileStream fStream = File.Open(dateiname, FileMode.OpenOrCreate);

            // Erzeugen einer neuen RijndaelManaged-Instanz 
            RijndaelManaged aesAlg = new RijndaelManaged();

            // Erzeugen eines CryptoStream mit dem FileStream und dem bergebenen
            // Schlssel und IV
            CryptoStream cStream = new CryptoStream(fStream, aesAlg.CreateEncryptor(schluessel, iv), CryptoStreamMode.Write);

            // Erzeugen eines StreamWriter mit dem CryptoStream.
            StreamWriter sWriter = new StreamWriter(cStream);

            try
            {
                // Klartext, d.h. die zu verschlsselnden Daten, in den Stream schreiben
                sWriter.WriteLine(klartext);
            }
            catch (Exception e)
            {
                Console.WriteLine("Fehler beim Verschlsseln: {0}", e.Message);
            }
            finally
            {
                // Streams schlieen
                sWriter.Close();
                cStream.Close();
                fStream.Close();
            }

            // Vertrauliche Daten lschen
            aesAlg.Clear();
        }
        catch (Exception e)
        {
            Console.WriteLine("Fehler beim Verschlsseln: {0}", e.Message);
        }
    }


    public static string AESEntschluessele(String dateiname, byte[] schluessel, byte[] iv)
    {
        try
        {
            // ffnen der Datei
            FileStream fStream = File.Open(dateiname, FileMode.Open);

            // Erzeugen einer neuen RijndaelManaged-Instanz 
            RijndaelManaged aesAlg = new RijndaelManaged();

            // Erzeugen eines CryptoStream mit dem FileStream und dem bergebenen
            // Schlssel und IV
            CryptoStream cStream = new CryptoStream(fStream, aesAlg.CreateDecryptor(schluessel, iv), CryptoStreamMode.Read);

            // Erzeugen eines StreamReader mit dem CryptoStream.
            StreamReader sReader = new StreamReader(cStream);

            string entschluesselterText = null;

            try
            {
                // Entschlsselte Daten aus dem Stream lesen
                entschluesselterText = sReader.ReadLine();
            }
            catch (Exception e)
            {
                Console.WriteLine("Fehler beim Entschlsseln: {0}", e.Message);
            }
            finally
            {
                // Streams und Datei schlieen
                sReader.Close();
                cStream.Close();
                fStream.Close();
            }

            // Vertrauliche Daten lschen
            aesAlg.Clear();
 
            // entschlsselten Text zurckgeben
            return entschluesselterText;
        }
        catch (Exception e)
        {
            Console.WriteLine("Fehler beim Entschlsseln: {0}", e.Message);
            return null;
        }
    }
}